/* Process model C form file: tcp_app.pr.c */
/* Portions of this file Copyright (C) MIL 3, Inc. 1992 */



/* OPNET system definitions */
#include <opnet.h>
#include "tcp_app.pr.h"
FSM_EXT_DECS



/* Header block */
#define	PK_ARR	op_intrpt_type () == OPC_INTRPT_STRM
#define	SELF_INT0	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 0)
#define	SELF_INT1	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 1)
#define	SELF_INT2	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 2)
#define	SELF_INT3	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 3)

#define END_SIM		op_intrpt_type () ==  OPC_INTRPT_ENDSIM

extern int TCP;




/* State variable definitions */
typedef struct
	{
	FSM_SYS_STATE
	Objid	                  		sv_my_id;
	Objid	                  		sv_ip_objid;
	int	                    		sv_sess;
	int	                    		sv_dgram_id;
	int	                    		sv_data_len;
	double	                 		sv_tim;
	double	                 		sv_data_rec;
	Distribution*           		sv_net_dist;
	Distribution*           		sv_node_dist;
	Distribution*           		sv_time_dist;
	Distribution*           		sv_term_dist;
	double                  		sv_sessmin;
	double                  		sv_sessmax;
	double                  		sv_data_iat;
	double                  		sv_sess_iat;
	int	                    		sv_Max_net;
	int	                    		sv_my_net;
	int	                    		sv_my_node;
	int	                    		sv_dest_net;
	int	                    		sv_dest_node;
	} tcp_app_state;

#define pr_state_ptr            		((tcp_app_state*) SimI_Mod_State_Ptr)
#define my_id                   		pr_state_ptr->sv_my_id
#define ip_objid                		pr_state_ptr->sv_ip_objid
#define sess                    		pr_state_ptr->sv_sess
#define dgram_id                		pr_state_ptr->sv_dgram_id
#define data_len                		pr_state_ptr->sv_data_len
#define tim                     		pr_state_ptr->sv_tim
#define data_rec                		pr_state_ptr->sv_data_rec
#define net_dist                		pr_state_ptr->sv_net_dist
#define node_dist               		pr_state_ptr->sv_node_dist
#define time_dist               		pr_state_ptr->sv_time_dist
#define term_dist               		pr_state_ptr->sv_term_dist
#define sessmin                 		pr_state_ptr->sv_sessmin
#define sessmax                 		pr_state_ptr->sv_sessmax
#define data_iat                		pr_state_ptr->sv_data_iat
#define sess_iat                		pr_state_ptr->sv_sess_iat
#define Max_net                 		pr_state_ptr->sv_Max_net
#define my_net                  		pr_state_ptr->sv_my_net
#define my_node                 		pr_state_ptr->sv_my_node
#define dest_net                		pr_state_ptr->sv_dest_net
#define dest_node               		pr_state_ptr->sv_dest_node




/* Process model interrupt handling procedure */



void
tcp_app ()
	{
	Packet  *pkptr,*ip_pkptr;
	int in_strm,da1,da2,da3;
	FILE*  fil;
	int  type,tmp_net,tmp_node;
	


	FSM_ENTER (tcp_app)

	FSM_BLOCK_SWITCH
		{
		/*---------------------------------------------------------*/
		/** state (init) enter executives **/
		FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init")
			{
			dgram_id = 0;
			my_id = op_id_self();
			ip_objid = op_topo_assoc (my_id, OPC_TOPO_ASSOC_OUT,
			                OPC_OBJMTYPE_MODULE, 0);
			 
			/* Use the object id to get the address */
			op_ima_obj_attr_get (ip_objid, "net_num0", &my_net);
			op_ima_obj_attr_get (ip_objid, "node_num0", &my_node);
			
			data_rec = 0;
			
			op_ima_obj_attr_get(my_id,"SESSMIN",&sessmin);
			op_ima_obj_attr_get(my_id,"SESSMAX",&sessmax);
			op_ima_obj_attr_get(my_id,"DATA_IAT", &data_iat);
			op_ima_obj_attr_get(my_id,"SESS_IAT",&sess_iat);
			op_ima_obj_attr_get(my_id,"MAX_NET",&Max_net);
			
			node_dist = op_dist_load("uniform_int",0,4);
			net_dist = op_dist_load("uniform_int",0,Max_net);
			
			/*time when he joins initially*/
			time_dist = op_dist_load("exponential",sess_iat,0);
			tim = op_dist_outcome(time_dist);
			op_intrpt_schedule_self((op_sim_time() + tim + 1),0);/*for conn request*/
			sess = 0;
			
			
			term_dist = op_dist_load("uniform",sessmin,sessmax);
			
			}


		/** state (init) exit executives **/
		FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init")
			{
			}


		/** state (init) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (idle) enter executives **/
		FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle")
			{
			}


		/** blocking after enter executives of unforced state. **/
		FSM_EXIT (3,tcp_app)


		/** state (idle) exit executives **/
		FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle")
			{
			}


		/** state (idle) transition processing **/
		FSM_INIT_COND (PK_ARR)
		FSM_TEST_COND (SELF_INT0)
		FSM_TEST_COND (sess && SELF_INT1)
		FSM_TEST_COND (SELF_INT2)
		FSM_TEST_COND (SELF_INT3)
		FSM_DFLT_COND
		FSM_TEST_LOGIC ("idle")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 5, state5_enter_exec, ;)
			FSM_CASE_TRANSIT (2, 4, state4_enter_exec, ;)
			FSM_CASE_TRANSIT (3, 3, state3_enter_exec, ;)
			FSM_CASE_TRANSIT (4, 6, state6_enter_exec, ;)
			FSM_CASE_TRANSIT (5, 1, state1_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (pk_arr) enter executives **/
		FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "pk_arr")
			{
			ip_pkptr  = op_pk_get (op_intrpt_strm ());
			
			
			op_pk_nfd_get(ip_pkptr,"data",&pkptr);
			op_pk_nfd_get(pkptr,"type",&type);
			
			if(type == 1)
			{	/*send back a accept for TCP connection*/
			 	op_pk_nfd_get(ip_pkptr,"src_node",&tmp_node);	
			 	op_pk_nfd_get(ip_pkptr,"src_net",&tmp_net);	
				op_pk_nfd_set(ip_pkptr,"src_node", my_node);
				op_pk_nfd_set(ip_pkptr,"src_net", my_net);
			
			   	op_pk_nfd_set(ip_pkptr,"dest_net", tmp_net);
				op_pk_nfd_set(ip_pkptr,"dest_node",tmp_node);
				op_pk_nfd_set(ip_pkptr,"ttl",10);
			
				op_pk_nfd_set(pkptr,"type", 2);
				data_len = op_pk_total_size_get (pkptr) / 8;
				op_pk_nfd_set(ip_pkptr,"data",pkptr);
				op_pk_bulk_size_set (ip_pkptr, data_len * 8);
				op_pk_nfd_set (ip_pkptr, "orig_len", data_len);
				op_pk_nfd_set (ip_pkptr, "frag_len", data_len);
				op_pk_nfd_set (ip_pkptr, "frag", 0);
				op_pk_nfd_set (ip_pkptr, "ident", dgram_id++);
			
				op_pk_send(ip_pkptr,0);
			}
			
			else 
			{ if(type == 2)
				{ /* I got a positive acknowledge so can start sending data out*/
				  printf("Got a Conn req at %d.%d\n",my_net,my_node);
				  sess = 1;
				  op_intrpt_schedule_self(op_sim_time() + data_iat, 1);
				  tim = op_dist_outcome(term_dist);
				  op_intrpt_schedule_self((op_sim_time() + tim),2);
				  op_intrpt_disable(OPC_INTRPT_SELF, 3, OPC_TRUE);
				}
			  op_pk_destroy(pkptr);
			  op_pk_destroy(ip_pkptr);
			}	
			
			}


		/** state (pk_arr) exit executives **/
		FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "pk_arr")
			{
			}


		/** state (pk_arr) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (JOIN_TERM) enter executives **/
		FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "JOIN_TERM")
			{
			
			sess=0;
			/*next joining time*/
			tim = op_dist_outcome(time_dist);
			op_intrpt_schedule_self((op_sim_time() + tim),0);
			
			
			}


		/** state (JOIN_TERM) exit executives **/
		FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "JOIN_TERM")
			{
			}


		/** state (JOIN_TERM) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (data) enter executives **/
		FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "data")
			{
			
			if(sess)
			{/*create a dummy packet*/
			pkptr = op_pk_create_fmt("tcp_pk");
			op_pk_nfd_set(pkptr,"type",0);
			data_len = op_pk_total_size_get (pkptr) / 8;
			
			ip_pkptr = op_pk_create_fmt("ip_dgram");
			op_pk_nfd_set(ip_pkptr,"data",pkptr);
			op_pk_bulk_size_set (ip_pkptr, data_len * 8);
			op_pk_nfd_set(ip_pkptr,"prot_id",TCP);
			op_pk_nfd_set(ip_pkptr,"ttl",10);
			op_pk_nfd_set(ip_pkptr,"src_node", my_node);
			op_pk_nfd_set(ip_pkptr,"src_net", my_net);
			op_pk_nfd_set(ip_pkptr,"dest_net", dest_net);
			op_pk_nfd_set(ip_pkptr,"dest_node",dest_node);
			/* set the length attributes of the IP packet. */
			op_pk_nfd_set (ip_pkptr, "orig_len", data_len);
			op_pk_nfd_set (ip_pkptr, "frag_len", data_len);
			
			/* Indicate that the packet is not yet fragmented. */
			op_pk_nfd_set (ip_pkptr, "frag", 0);
			 
			/* Assign a unique identity to this packet (unique among */
			/* packets injected into the net by this host. */
			op_pk_nfd_set (ip_pkptr, "ident", dgram_id++);
			
			op_pk_send(ip_pkptr,0);
			op_intrpt_schedule_self((op_sim_time() + (data_iat)),1);
			
			}
			
			if(dgram_id > 10000) dgram_id = 0;
			
			}


		/** state (data) exit executives **/
		FSM_STATE_EXIT_FORCED (4, state4_exit_exec, "data")
			{
			}


		/** state (data) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (SEND_CO) enter executives **/
		FSM_STATE_ENTER_FORCED (5, state5_enter_exec, "SEND_CO")
			{
			dest_net = my_net; dest_node = my_node;
			 
			if(sess)op_sim_end("Session exists so why a new session","","","");
			
			while(dest_net == my_net && dest_node == my_node)
			{
			dest_net =  op_dist_outcome(net_dist);
			dest_node =  op_dist_outcome(node_dist);
			}
			
			printf("%d.%d sending a tcp conn req to %d.%d\n",my_net,my_node,dest_net,dest_node);
			pkptr = op_pk_create_fmt("tcp_pk");
			op_pk_nfd_set(pkptr,"type",1);
			data_len = op_pk_total_size_get (pkptr) / 8;
			
			ip_pkptr = op_pk_create_fmt("ip_dgram");
			op_pk_nfd_set(ip_pkptr,"data",pkptr);
			op_pk_bulk_size_set (ip_pkptr, data_len * 8); 
			op_pk_nfd_set(ip_pkptr,"prot_id",TCP);
			op_pk_nfd_set(ip_pkptr,"ttl",10);
			op_pk_nfd_set(ip_pkptr,"src_node", my_node);
			op_pk_nfd_set(ip_pkptr,"src_net", my_net);
			op_pk_nfd_set(ip_pkptr,"dest_net", dest_net);
			op_pk_nfd_set(ip_pkptr,"dest_node",dest_node);
			
			/* set the length attributes of the IP packet. */ 
			op_pk_nfd_set (ip_pkptr, "orig_len", data_len);
			op_pk_nfd_set (ip_pkptr, "frag_len", data_len); 
			
			/* Indicate that the packet is not yet fragmented. */ 
			op_pk_nfd_set (ip_pkptr, "frag", 0);
			
			/* Assign a unique identity to this packet (unique among */ 
			/* packets injected into the net by this host. */ 
			op_pk_nfd_set (ip_pkptr, "ident", dgram_id++); 
			
			op_pk_send(ip_pkptr,0);
			op_intrpt_schedule_self(op_sim_time() + 30, 3);
			
			if(dgram_id > 10000) dgram_id = 0; 
			}


		/** state (SEND_CO) exit executives **/
		FSM_STATE_EXIT_FORCED (5, state5_exit_exec, "SEND_CO")
			{
			}


		/** state (SEND_CO) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (disconn) enter executives **/
		FSM_STATE_ENTER_FORCED (6, state6_enter_exec, "disconn")
			{
			tim = op_dist_outcome(time_dist);
			op_intrpt_schedule_self((op_sim_time() + tim),0);
			printf("%d.%d didn't get a conn ack\n",my_net,my_node);
			
			}


		/** state (disconn) exit executives **/
		FSM_STATE_EXIT_FORCED (6, state6_exit_exec, "disconn")
			{
			}


		/** state (disconn) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		}


	FSM_EXIT (0,tcp_app)
	}




void
tcp_app_svar (prs_ptr,var_name,var_p_ptr)
	tcp_app_state		*prs_ptr;
	char			*var_name, **var_p_ptr;
	{

	FIN (tcp_app_svar (prs_ptr))

	*var_p_ptr = VOS_NIL;
	if (Vos_String_Equal ("my_id" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_my_id);
	if (Vos_String_Equal ("ip_objid" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_ip_objid);
	if (Vos_String_Equal ("sess" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sess);
	if (Vos_String_Equal ("dgram_id" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_dgram_id);
	if (Vos_String_Equal ("data_len" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_len);
	if (Vos_String_Equal ("tim" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_tim);
	if (Vos_String_Equal ("data_rec" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_rec);
	if (Vos_String_Equal ("net_dist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_net_dist);
	if (Vos_String_Equal ("node_dist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_node_dist);
	if (Vos_String_Equal ("time_dist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_time_dist);
	if (Vos_String_Equal ("term_dist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_term_dist);
	if (Vos_String_Equal ("sessmin" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sessmin);
	if (Vos_String_Equal ("sessmax" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sessmax);
	if (Vos_String_Equal ("data_iat" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_iat);
	if (Vos_String_Equal ("sess_iat" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sess_iat);
	if (Vos_String_Equal ("Max_net" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_Max_net);
	if (Vos_String_Equal ("my_net" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_my_net);
	if (Vos_String_Equal ("my_node" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_my_node);
	if (Vos_String_Equal ("dest_net" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_dest_net);
	if (Vos_String_Equal ("dest_node" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_dest_node);

	FOUT;
	}




void
tcp_app_diag ()
	{
	Packet  *pkptr,*ip_pkptr;
	int in_strm,da1,da2,da3;
	FILE*  fil;
	int  type,tmp_net,tmp_node;
	

	FIN (tcp_app_diag ())


	FOUT;
	}




void
tcp_app_terminate ()
	{
	Packet  *pkptr,*ip_pkptr;
	int in_strm,da1,da2,da3;
	FILE*  fil;
	int  type,tmp_net,tmp_node;
	

	FIN (tcp_app_terminate ())


	FOUT;
	}



Compcode
tcp_app_init (pr_state_pptr)
	tcp_app_state			**pr_state_pptr;
	{
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (tcp_app_init (pr_state_pptr))

	if (obtype == OPC_NIL)
		{
		if (Vos_Catmem_Register ("proc state vars (tcp_app)",
			sizeof (tcp_app_state), Vos_Nop, &obtype) == VOSC_FAILURE)
			FRET (OPC_COMPCODE_FAILURE)
		}

	if ((*pr_state_pptr = (tcp_app_state*) Vos_Catmem_Alloc (obtype, 1)) == OPC_NIL)
		FRET (OPC_COMPCODE_FAILURE)
	else
		{
		(*pr_state_pptr)->current_block = 0;
		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



